 	(** Fonction qui transforme un nom de fonction OCAML en nom de fonction satisfaisant pour MGS *)
	let transforme_nom chaine =
  		let rec trans_nom c taille indice acc =
    		if(indice<taille)
    			then
			begin
      			match String.sub c indice (min 5 (taille-indice)) with
			(* On utilise le code ASCII du caractere *)
			(*"<" ->  trans_nom c taille (indice+1) (acc^"__060")*)
			|"__060" ->  trans_nom c taille (indice+5) (acc^"<")
			(*"=" ->  trans_nom c taille (indice+1) (acc^"__061")*)
			|"__061" ->  trans_nom c taille (indice+5) (acc^"=")
			(*">" ->  trans_nom c taille (indice+1) (acc^"__062")*)
			|"__062" ->  trans_nom c taille (indice+5) (acc^">")
			(*"?" ->  trans_nom c taille (indice+1) (acc^"__063")*)
			|"__063" ->  trans_nom c taille (indice+5) (acc^"?")
			(*"+" ->  trans_nom c taille (indice+1) (acc^"__043")*)
			|"__043" ->  trans_nom c taille (indice+5) (acc^"+")
			|"__045" ->  trans_nom c taille (indice+5) (acc^"-")
			|"__042" ->  trans_nom c taille (indice+5) (acc^"*")
			|"__047" ->  trans_nom c taille (indice+5) (acc^"/")
			(*"!" ->  trans_nom c taille (indice+1) (acc^"__033")*)
			|"__033" ->  trans_nom c taille (indice+5) (acc^"!")
			(*":" ->  trans_nom c taille (indice+1) (acc^"__058")*)
			|"__058" ->  trans_nom c taille (indice+5) (acc^":")
			(*"|" ->  trans_nom c taille (indice+1) (acc^"__124")*)
			|"__124" ->  trans_nom c taille (indice+5) (acc^"|")
			|t when (compare (String.sub t 0 (min 5 (taille-indice)) ) "____'" = 0)  -> trans_nom c taille (indice+5) (acc^(String.sub t 4 1))
			|t when (compare (String.sub t 0 (min 4 (taille-indice)) ) "____" = 0)  -> trans_nom c taille (indice+4) (acc^(String.sub t 4 0))

			(*"\"" -> trans_nom c taille (indice+1) (acc)*)
			|_ as t -> trans_nom c taille (indice+1) (acc^(String.sub t 0 1))
    		end
		else
      			acc
  		in
    		(trans_nom chaine (String.length chaine) 0 "")
;;


 	(** Fonction qui transforme un nom de fonction OCAML en nom de fonction satisfaisant pour MGS sans '*)
	let transforme_nom2 chaine =
	  let c = transforme_nom chaine in
	    if (c.[0]='\'') then (String.sub  c 1 ((String.length c)-1)) else c;;






(** Fonction qui supprime Type d'une chaine de caractres *)
	let suppression_type chaine =
  		let rec trans_nom c taille indice acc =
    		if(indice<taille)
    			then
			begin
      			match String.sub c indice (min 4 (taille-indice)) with
			|"Type" ->  trans_nom c taille (indice+5) (acc)
			|_ as t -> trans_nom c taille (indice+1) (acc^(String.sub t 0 1))
    		end
		else
      			acc
  		in
    		(trans_nom chaine (String.length chaine) 0 "")
;;



type voir =
	Module of string*string
	|ModFonct of string*string*string
	|Fonction of string*string
	|URL of string*string;;




(** Fonction qui transforme un nom de fonction MGS en nom de fonction satisfaisant pour ocamldoc *)
let code chaine =
  let rec trans_nom c taille indice acc =
    if(indice<taille)
    then
begin
      match String.sub c indice 1 with
(* On utilise le code ASCII du caractere *)
	|"<" ->  trans_nom c taille (indice+1) (acc^"__060")
	|"=" ->  trans_nom c taille (indice+1) (acc^"__061")
	|"*" ->  trans_nom c taille (indice+1) (acc^"__042")
	|">" ->  trans_nom c taille (indice+1) (acc^"__062")
	|"?" ->  trans_nom c taille (indice+1) (acc^"__063")
	|"+" ->  trans_nom c taille (indice+1) (acc^"__043")
	|"-" ->  trans_nom c taille (indice+1) (acc^"__045")
	|"!" ->  trans_nom c taille (indice+1) (acc^"__033")
	|":" ->  trans_nom c taille (indice+1) (acc^"__058")
	|"|" ->  trans_nom c taille (indice+1) (acc^"__124")
	|"\"" -> trans_nom c taille (indice+1) (acc)
	|_ as t ->
	   if (indice+3<taille)
	   then
	    match String.sub c indice 4 with
	      |"&lt;" -> trans_nom c taille (indice+4) (acc^"__060")
	      |"&gt;" -> trans_nom c taille (indice+4) (acc^"__062")
	      |_ -> trans_nom c taille (indice+1) (acc^t)
	   else
	   trans_nom c taille (indice+1) (acc^t)
end
    else
      acc
  in
    "____"^(trans_nom chaine (String.length chaine) 0 "");;
