{
open Outil
open List
exception Eof
let a =ref true;;


(** La liste des fonctions *)
let l = ref ([]:Outil.type_commentaire list)
(** est-ce qu'il y  a un commentaire qui a deja commenc *) 
and yacomm = ref false
(** est-ce que dans le commentaire il y a le nom de la fonction *)
and yanom = ref false
(** est-ce qu'il y a des alias  faire *)
and yaalias = ref false
(** liste des alias  faire *)
and liste_alias = ref []
(** module alias_courant *)
and module_alias = ref ""
(** buffer commentaire *)
and buff = Buffer.create 100;;
 


let nouveau_com() =
if(not !yacomm) then let h=({name ="" ;
			 commentaire="";
			 types=[];
			 modules="";
			 typecom=0;
			 recherche=""}) in l:=h::(!l);
yacomm:=false;;


let decoupage chaine =

  let ajout c l =
    match l with
	[]->[c]
        |t::q->(t^c)::q
  in

	let rec decoupe chaine longueur indice acc=
		if (indice<>longueur)
			then
			  match String.sub chaine indice 1 with
					"_"->decoupe chaine longueur (indice+1) (""::acc)
					|_ as c->decoupe chaine longueur (indice+1) (ajout c acc)
			else
				rev acc
	in
	let rec supprime_dernier l =
		match l with
		[]->[]
		|t::[]->[]
		|t::q->t::(supprime_dernier q)
	in
	(*supprime_dernier*) (decoupe chaine (String.length chaine) 0 []);;


let enleve_espace c =
  let a = String.index c '#' 
  and b = String.rindex c '#'
  in
  let m =(max a b) +1
  in
    String.sub c m ((String.length c)-m);;


let rec verif_type liste =
		match liste with
		[]->[]
		|t::q when (compare t "rec")=0 ->"record"::(verif_type q)
		|t::q when t.[0]='\'' -> (String.sub t 1 ((String.length t)-1))::(verif_type q)
		|t::q -> t::(verif_type q);;


let copie () =
  let copie_alias x =
    let t = hd(!l) in
      t.name<-snd x;
      t.modules<-fst x
  in

  if(!yaalias)
  then
    begin
prerr_endline "*******************************************************";
      List.iter copie_alias (!liste_alias);
      liste_alias:=[];
      yaalias:=false;
    end;;


}



rule lexer =
parse
   "(*!*)" 	{texte lexbuf}
   | eof        {(*prerr_endline "FIN1";*)rev !l }
   |_		{(*prerr_endline  ("//////////////////\t"^((Lexing.lexeme lexbuf)));*)lexer lexbuf}

and texte =
parse
    "(**"	{copie();yacomm:=false;(*prerr_endline "Com";*)nouveau_com();debut_comm lexbuf}
    |"(***"	{copie();yacomm:=false;(*prerr_endline "Com";*)nouveau_com();(hd(!l)).typecom=1;debut_comm lexbuf}
    |"addenv"	{(*prerr_endline "Add";*)nouveau_com(); fonction   lexbuf}
    | eof       {(*prerr_endline "FIN2";*)rev  !l}
    |"(*!*)"	{(*prerr_endline "DEBUT";*)lexer	    lexbuf} 
    |_		{(*prerr_endline  ("=================\t"^((Lexing.lexeme lexbuf)));*)texte      lexbuf}

and debut_comm =	
parse
    "@name"	{nom_commentaire    	lexbuf}
    |"@type"	{type_commentaire   	lexbuf}
    |"@module"	{module_commentaire 	lexbuf}
    |"@find"	{recherche_commentaire 	lexbuf}
    |"@alias"		{alias 	lexbuf}
    |"*)"		{(hd(!l)).commentaire<-(let c = Buffer.contents buff in if (c<>"") then ("(**"^c^"*)") else (""));
			 Buffer.reset buff;
			 yacomm:=true;
			 texte	lexbuf}
    |_			{Buffer.add_string buff (Lexing.lexeme lexbuf);debut_comm lexbuf}
and nom_commentaire =
parse
    [^'\n'' ''\t''\r']+		{(*prerr_endline ("NOM\t"^(Lexing.lexeme lexbuf));*)yanom:=true;(hd(!l)).name<-(Lexing.lexeme lexbuf);debut_comm lexbuf}
    |_				{(*prerr_endline ("#############\t"^(Lexing.lexeme lexbuf));*)nom_commentaire lexbuf} 
and type_commentaire =
parse
    [^'\n'' ''\t''\r']+		{(*prerr_endline ("TYPE\t"^(Lexing.lexeme lexbuf));*)(hd(!l)).types<- (((verif_type(decoupage(Lexing.lexeme lexbuf)))))::((hd(!l)).types) ;debut_comm lexbuf}
    |_				{(*prerr_endline  ("++++++++++++++++\t"^((Lexing.lexeme lexbuf)));*)type_commentaire lexbuf}	
and module_commentaire =
parse
    [^'\n'' ''\t''\r']+		{(*prerr_endline ("MODULE\t"^(Lexing.lexeme lexbuf));*)(hd(!l)).modules<-(Lexing.lexeme lexbuf);debut_comm lexbuf}
    |_				{(*prerr_endline  ("++++++++++++++++\t"^((Lexing.lexeme lexbuf)));*)module_commentaire lexbuf}	
and recherche_commentaire =
parse
    [^'\n'' ''\t''\r']+		{(*prerr_endline ("RECHERCHE\t"^(Lexing.lexeme lexbuf));*)(hd(!l)).recherche<-(Lexing.lexeme lexbuf);debut_comm lexbuf}
    |_				{(*prerr_endline  ("++++++++++++++++\t"^((Lexing.lexeme lexbuf)));*)recherche_commentaire lexbuf}
and fonction =
parse
    '\"'			{nom_fonction lexbuf}
    |_				{(*prerr_endline  ("*****************\t"^((Lexing.lexeme lexbuf)));*)fonction lexbuf}
and nom_fonction =	
parse
    [^'\"'' ''\t''\r']+		{(*prerr_endline  ("FONCTION\t"^(Lexing.lexeme lexbuf));*)yacomm:=false;(hd(!l)).name<-(Lexing.lexeme lexbuf);texte lexbuf}
    |_				{(*prerr_endline  ("++++++++++++++++\t"^((Lexing.lexeme lexbuf)));*)nom_fonction lexbuf}
    
and alias =
parse
    [^'\n'' ''\t''\r''.']+      {module_alias:=(Lexing.lexeme lexbuf);alias_point lexbuf}
    |_				{alias lexbuf}
and alias_point =
parse
    '.'      			{alias_fonction lexbuf}
    |_				{alias_point lexbuf}
and alias_fonction =
parse
    [^'\n'' ''\t''\r']+         {yaalias:=true;liste_alias:=(!module_alias,(Lexing.lexeme lexbuf))::(!liste_alias);debut_comm lexbuf}
    |_			 	{alias_fonction lexbuf}


