%{
open Outil
open StdLabels
open StdLabels.List




let decoupage chaine =

  let ajout c l =
    match l with
	[]->[c]
        |t::q->(t^c)::q
  in

	let rec decoupe chaine longueur indice acc=
		if (indice<>longueur)
			then
			  match String.sub chaine indice 1 with
					"_"->decoupe chaine longueur (indice+1) (""::acc)
					|_ as c->decoupe chaine longueur (indice+1) (ajout c acc)
			else
				rev acc
	in
	let rec supprime_dernier l =
		match l with
		[]->[]
		|t::[]->[]
		|t::q->t::(supprime_dernier q)
	in
	(*supprime_dernier*) (decoupe chaine (String.length chaine) 0 []);;


let enleve_espace c =
  let a = String.index c '#' 
  and b = String.rindex c '#'
  in
  let m =(max a b) +1
  in
    String.sub c m ((String.length c)-m);;


let rec verif_type liste =
		match liste with
		[]->[]
		|t::q when (compare t "rec")=0 ->"record"::(verif_type q)
		|t::q when t.[0]='\'' -> (String.sub t 1 ((String.length t)-1))::(verif_type q)
		|t::q -> t::(verif_type q);;

%}

%token Fin Fonct Instr CommentaireMod CommentaireFonc FinCom   
%token <string> Nom Commentaire Module Type Fonction Comm Recherche


%right CommentaireMod 
%right CommentaireFonc 
%right Fin


%start depart
%type <Outil.type_commentaire list> depart


  
%%
depart :
	commentairefonction depart      {let (n,t,nf,r,c,tc,nom) = $1 in 
						  
						    {name =(if(nf<>"") then nf else nom) ;
						     commentaire=(if(c<>"") then "(** "^c^" *)" else "");
						     types=t;
						     modules=n;
						     typecom=tc;
						     recherche=r}::$2}
	|Fin {[]}



commentairefonction :
	commentaire fonction {let (n,t,nf,r,c,tc) = $1 in let nom = $2 in (n,t,nf,r,c,tc,nom)}
	|commentaire         {let (n,t,nf,r,c,tc) = $1 in (n,t,nf,r,c,tc,"")}
	|fonction	     {let nom = $1 in ("",[],"","","",0,nom)}

fonction :
	| Fonct Nom Instr {$2}

commentaire :
	|CommentaireMod  nommodule types nomfonction recherche comm FinCom  {($2,$3,$4,$5,$6,1)}
	|CommentaireFonc nommodule types nomfonction recherche comm FinCom  {($2,$3,$4,$5,$6,0)}

nommodule :
        {""}
	|Module {enleve_espace $1}

nomfonction :
        {""}
	|Fonction {enleve_espace $1}


recherche :
        {""}
	|Recherche {enleve_espace $1}

types :
        {[]}
	|Type types {let s=enleve_espace $1 in let l = decoupage s in (verif_type l)::$2}


comm :
        {""}
	|Comm comm {$1^$2}
