


open Outil

(**************************** Variable *************************************************)

(** Variable contenant le nom du fichier {b kernel.ml} *)
let kernel = ref ["kernel.ml"];;
(** Variable contenant le nom du fichier {b LIST_dispatch.txt} *)
let fichier_liste = ref "LIST_dispatch.txt";;
(** Variable contenant le chemin vers les fichiers {b LIST_dispatch.txt} et {b kernel.ml} *)
let chemin_recherche = ref "fichier/";;
(** Variable contenant le chemin vers les fichiers *.mli} *)
let chemin_ecriture = ref "doc/";;
(** Variable indiquant si le programme est en mode verbeux *)
let mode_verbose = ref false;;
(** Variable contenant le nom du module courant  *)
let module_courant = ref "divers";;
(** Variable contenant le type courant  *)
let type_courant = ref [];;
(** Variable contenant le chemin ou va etre place la doc generee *)
let chemin_doc = ref "doc/";;
(***************************** Fonction d'affichage *************************************)

let rec affichage_type liste =
	match liste with 
	[] ->()
	|t::q->Printf.printf "%s\n" t;affichage_type q;;



let rec affichage_argument liste =
	match liste with
	[] ->()
	|t::[]-> Printf.printf "%s\t" t
	|t::q->Printf.printf "%s\t -> " t ;affichage_argument q;;

	
let rec affichage_arguments liste =
	match liste with
	[] ->()
	|t::[]->affichage_argument t;Printf.printf "\n"
	|t::q->affichage_argument t; Printf.printf "\n\t";affichage_arguments q;;
	
let rec affichage_fonction (liste:Outil.type_fonction list) =
	match liste with 
	[] ->()
	|{nom=n;typ=t}::q->Printf.printf "%s \t: \n\t" n;affichage_arguments t;affichage_fonction q;;



let rec affichage_fonction_brut l =
	match l with
	[]->()
	|t::q->Printf.printf "%s : %s \n" (t.name) (t.commentaire);affichage_fonction_brut q;;


let rec afficher_fct liste =
	match liste with
	[]->()
	|t::q-> Printf.printf "\t\t%s \t:\t %s\n" t.name t.commentaire;afficher_fct q;;

	
let rec afficher_module liste =
	match liste with 
	[]->()
	|t::q-> Printf.printf "%s \t:\n\tcom %s\n" t.modul t.com;afficher_fct (t.contenu);afficher_module q;;
	

(********************************* Fonction Auxiliaire ***************************************************)

(** Fonction de comparaison pour le type [type_fonction] *)
let compare_type_fonction a b = compare a.nom b.nom;;
	
(** Fonction qui a partir d'une liste de chaine de caractere contenant l'ensemble des types cree un fichier type.mli *)
let creation_type_mli liste =
	let descrfichier= Unix.openfile ((!chemin_ecriture)^"/type.mli") [Unix.O_WRONLY;Unix.O_CREAT;Unix.O_TRUNC] 0o755 in
	let rec parcourt l d =
		match l with
		[]->()
		|t::q->let chaine="type "^t^" = zz \n" in
			let _=Unix.write d chaine 0 (String.length chaine) 
			in parcourt q d
	in
	let chaine = "type zz = int list\n" in
	let _=Unix.write descrfichier chaine 0 (String.length chaine) in
	parcourt liste descrfichier;
	Unix.close descrfichier;;

(** Fonction qui decoupe le texte s pour renvoyer seulement le texte qui se trouve entre les balises (*!*) *)
let decoupage_text s =
let rec decoupe_text chaine longueur indice debut niveau acc=
	if(indice<longueur)
	then begin
		match (String.sub chaine indice 1) with
		|"(" as s when niveau=0 && debut ->decoupe_text chaine longueur (indice+1) debut 1 (acc^s)
		|"(" as s when niveau=0 && (not debut) ->decoupe_text chaine longueur (indice+1) debut 1 acc
		|"(" as s when niveau<>0 && debut ->decoupe_text chaine longueur (indice+1) debut 0 (acc^s)
		|"(" as s when niveau<>0 && (not debut) ->decoupe_text chaine longueur (indice+1) debut 0 acc
		
		|"*" as s when niveau=1 && debut ->decoupe_text chaine longueur (indice+1) debut 2 (acc^s)
		|"*" as s when niveau=1 && (not debut) ->decoupe_text chaine longueur (indice+1) debut 2 acc
	(*	|"*" as s when niveau<>1 && debut ->decoupe_text chaine longueur (indice+1) debut 0 (acc^s)
		|"*" as s when niveau<>1 && (not debut) ->decoupe_text chaine longueur (indice+1) debut 0 acc
	*)	
		
		|"*" as s when niveau=3 && debut ->decoupe_text chaine longueur (indice+1) debut 4 (acc^s)
		|"*" as s when niveau=3 && (not debut) ->decoupe_text chaine longueur (indice+1) debut 4 acc
		|"*" as s when niveau<>3 && niveau<>1 && debut ->decoupe_text chaine longueur (indice+1) debut 0 (acc^s)
		|"*" as s when niveau<>3 && niveau<>1 && (not debut) ->decoupe_text chaine longueur (indice+1) debut 0 acc
		
		|"!" as s when niveau=2 && debut ->decoupe_text chaine longueur (indice+1) debut 3 (acc^s)
		|"!" as s when niveau=2 && (not debut) ->decoupe_text chaine longueur (indice+1) debut 3 acc
		|"!" as s when niveau<>2 && debut ->decoupe_text chaine longueur (indice+1) debut 0 (acc^s)
		|"!" as s when niveau<>2 && (not debut) ->decoupe_text chaine longueur (indice+1) debut 0 acc
		
		
		|")" as s when niveau=4 && debut ->decoupe_text chaine longueur (indice+1) (not debut) 0 (acc^s)
		|")" as s when niveau=4 && (not debut) ->decoupe_text chaine longueur (indice+1) (not debut) 0 acc
		|")" as s when niveau<>4 && debut ->decoupe_text chaine longueur (indice+1)  debut 0 (acc^s)
		|")" as s when niveau<>4 && (not debut) ->decoupe_text chaine longueur (indice+1) debut 0 acc
		
		|_ as s when debut -> decoupe_text chaine longueur (indice+1) debut 0 (acc^s)
		|_ as s(* when not debut*) -> decoupe_text chaine longueur (indice+1) debut 0 acc
	     end
	else acc
in
decoupe_text s (String.length s) 0 false 0 "";;	
	



(** Fonction qui rajoute a la liste des modules ( {i type_module list} ) la fonction [t] ( {i type_commentaire} ) dont le nomde module est la chaine de caractere [t].  *)
let rec remplir nom t liste =
	match liste with
	[] when (compare t.name "")=0 ->[{modul=nom;com=t.commentaire;contenu=[]}]
	|[] ->[{modul=nom;com="";contenu=[t]}]
	|tt::q when (compare tt.modul nom)=0 && (compare t.name "")=0 ->{modul=nom;com=t.commentaire^tt.com;contenu=tt.contenu}::q
	|tt::q when (compare tt.modul nom)=0  ->{modul=nom;com=tt.com;contenu=(tt.contenu@[t])}::q
	|tt::q   ->tt::(remplir nom t q);;

(** Fonction qui a partir d'une liste de fonction de type  {i type_commentaire list} renvoie une liste de module de type {i type_module list} *)	
let ranger l =
	let rec ranger_par_module liste_fonction liste_module =
		match liste_fonction with
		[]->liste_module 
		|t::q ->
			begin
			let nom =t.modules
			in
			  if(nom<>"") then module_courant := nom;
			let liste_mod = remplir !(module_courant)  t liste_module
			in
			ranger_par_module q liste_mod
			end
	in
	ranger_par_module l [];;

(** Fonction qui a partir du nom d'une fonction et de la liste des types ({i type_fonction list }), essaie de retrouver la liste des arguments *)
let rec retrouve_arg chaine l =
	match l with
	[]->[]
	|t::q when (compare t.nom chaine)=0 -> t.typ
	|t::q -> retrouve_arg chaine q;;




(** Fonction qui transforme un nom de fonction MGS en nom de fonction satisfaisant pour ocamldoc *)
let transforme_nom chaine =
  let rec trans_nom c taille indice acc =
    if(indice<taille)
    then
      begin
      match String.sub c indice 1 with
(* On utilise le code ASCII du caractere *)
	|"<" ->  trans_nom c taille (indice+1) (acc^"__060")
	|"=" ->  trans_nom c taille (indice+1) (acc^"__061")
	|">" ->  trans_nom c taille (indice+1) (acc^"__062")
	|"?" ->  trans_nom c taille (indice+1) (acc^"__063")
	|"+" ->  trans_nom c taille (indice+1) (acc^"__043")
	|"*" ->  trans_nom c taille (indice+1) (acc^"__042")
	|"/" ->  trans_nom c taille (indice+1) (acc^"__047")
	|"!" ->  trans_nom c taille (indice+1) (acc^"__033")
	|":" ->  trans_nom c taille (indice+1) (acc^"__058")
	|"|" ->  trans_nom c taille (indice+1) (acc^"__124")
	|"-" ->  trans_nom c taille (indice+1) (acc^"__045")
	|"\"" -> trans_nom c taille (indice+1) (acc)
	|_ as t -> trans_nom c taille (indice+1) (acc^t)
end
    else
      acc
  in
    "____"^(trans_nom chaine (String.length chaine) 0 "");;



(** Fonction qui transforme un nom de fonction MGS en nom de fonction satisfaisant pour ocamldoc pour un commentaire *)
let transforme_nom2 chaine = (String.sub chaine 1 ((String.length chaine)-1) );;




(** Fonction qui ecrit sur le fichier dont le descripteur de fichier est [descrfichier] la fonction dont le nom est [nom] et le type est [liste_arg] et le commentaire est [com] *) 
let rec ecrire_fonction nom liste_arg com descrfichier =
        match liste_arg with
	[]-> let chaine ="\n" in
	     let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		()
	|t::[] -> let chaine ="Type."^t in
	          let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		()
	|t::q-> 
		let chaine ="Type."^t^" -> " in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		ecrire_fonction nom q com descrfichier;;


(** Fonction qui ecrit sur le fichier dont le descripteur de fichier est [descrfichier] la fonction dont le nom est [nom] et le type est [liste_arg] et le commentaire est [com] *) 
let rec ecrire_fonction2 nom liste_arg com descrfichier =
        match liste_arg with
	[]-> let chaine ="\n" in
	     let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		()
	|t::[] -> let chaine =t in
	          let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		()
	|t::q-> 
		let chaine =t^" -> " in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		ecrire_fonction2 nom q com descrfichier;;
	

(** Fonction qui ecrit sur le fichier dont le descripteur de fichier est [descrfichier] la fonction dont le nom est [nom] et  le commentaire est [com] et les differents types d'argument est liste_arg ({b string list list} et types)*)
let rec ecrire_fonctions nom liste_arg com descrfichier i=
	match liste_arg with 
	[] (*when i<>0*) ->() (*FIXME *)
(*	|[] -> let typage = !type_courant in
	       let chaine =com^"\nval "^(transforme_nom nom)^" :  Type."^typage^" \n\n" 
	       in
		 type_courant := typage;
	              let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		      ()
	*)
	|[]::[] when i=0->let chaine =com^"\nval "^(transforme_nom nom)^" :  Type.unit \n\n" in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		()
	
	|[]::q when i=0->
	        let chaine ="\n\n (** \n" in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		ecrire_fonctions nom q com descrfichier 1;
	        let chaine ="\n\n"^(String.sub com 3 ((String.length com) -3))^"\nval "^(transforme_nom nom)^" :  Type.unit \n\n"(** {e Other types : } *) in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		(*let chaine =" *)\n\n " in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		  *)()

	|[]::q (*when i=1*)->let chaine ="\n  [unit] " in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		ecrire_fonctions nom q com descrfichier 1
	
		
		
		
	|t::[]  when i=0-> let chaine =com^"\nval "^(transforme_nom nom)^" : " in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		ecrire_fonction nom t com descrfichier;
		let chaine ="\n\n " in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		()

		
	|t::q  when i=0-> 
		let chaine ="\n\n (** \n" in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		ecrire_fonctions nom q com descrfichier 1;
	        let chaine ="\n\n"^(String.sub com 3 ((String.length com) -3))^"\nval "^(transforme_nom nom)^" : " in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		ecrire_fonction nom t com descrfichier;
		let chaine ="\n\n " in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in 
		()
	
 
	|t::q  (*when i=1*)-> let chaine ="\n[" in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		ecrire_fonction2 nom t com descrfichier;
		let chaine =" ]\n" in
		let _=Unix.write descrfichier chaine 0 (String.length chaine) in
		ecrire_fonctions nom q com descrfichier 1;;



 


(** Fonction qui a partir d'une liste de fonction ({i type_commentaire}) ecrit sur le fichier dont le descripteur de fichier est [descrfichier] le fichier d'interface *.mli correspondant sachant que les types des fonction se trouve dans la liste [liste_fonc] de type {i type_fonction list } *) 
let rec creation_fonction l liste_fonc descrfichier =
	match l with
	[]->()
	|t::q-> let nom=if(t.recherche<>"") then t.recherche else (let lg = (String.length t.name) in
								     (*if(lg>1)
								     then *)(String.sub t.name 1((String.length t.name)-1))
								     (*else t.name*)) in

	        let liste_arg = retrouve_arg nom liste_fonc
		in
		if((compare t.commentaire  "")=0) then t.commentaire<-"(** {b No comment} *)";
	        if(t.types<>[]) then 
		  begin
		    type_courant:=t.types;
		    ecrire_fonctions t.name (t.types(*@liste_arg*)) t.commentaire descrfichier 0;
		  end
		else
		  if(liste_arg=[]) then ecrire_fonctions t.name (!type_courant) t.commentaire descrfichier 0
		  else ecrire_fonctions t.name liste_arg t.commentaire descrfichier 0;
		creation_fonction q liste_fonc descrfichier;;

(** Fonction qui cree un fichier d'interface *.mli a partir d'une liste [l] de type ({i type_commentaire}) et d'une liste [liste_fonc] *)
let rec creation_mli l liste_fonc=
  match l with
	[]->()
	|t::q->let descrfichier= Unix.openfile ((!chemin_ecriture)^"/"^t.modul^".mli") [Unix.O_WRONLY;Unix.O_CREAT;Unix.O_TRUNC] 0o755 		in
			
			let chaine =if((compare t.com "")<>0) then ("(**"^(String.sub t.com 3 ((String.length t.com)-3))^"\n\n") else ("(**"^t.modul^" *)\n\n") in
			let _=Unix.write descrfichier chaine 0 (String.length chaine)
			in
			creation_fonction (t.contenu) liste_fonc descrfichier;
			Unix.close descrfichier;
			creation_mli q liste_fonc;;
	

(** Fonction qui ecrit la liste des module dans le fichier dont le descripteur de fichier est d *)
let rec creation_liste_module l d pre=
         match l with
         []->()
         |t::q->let chaine =pre^"/"^(!chemin_ecriture)^(t.modul)^".mli\t" in
                let _=Unix.write d chaine 0 (String.length chaine)
                in
                creation_liste_module q d pre;;

(** Fonction qui ecrit la liste des module dans le fichier dont le descripteur de fichier est d *)
let rec creation_liste_module2 l d =
	 match l with
	 []->()
	 |t::q->let chaine =(t.modul)^".mli\t" in
	        let _=Unix.write d chaine 0 (String.length chaine)
	        in
		creation_liste_module2 q d;;


(** Fonction principale *)   
let main = 
  let premier = ref true in
	let usage ="Usage : "^Sys.argv.(0)^" [option] \nCe logiciel sert a generer la doc de MGS\n"
	in
	Arg.parse [
	  ("-v",Arg.Unit(fun () -> mode_verbose:=true) ,"Mode verbose (Par defaut : non )" ) ;
	  ("-o",Arg.String(fun s ->  chemin_ecriture:=s) ,("Chemin d'ecriture (Par defaut : "^(!chemin_ecriture)^" )" )) ;
	  ("-I",Arg.String(fun s ->  chemin_recherche:=s) ,("Chemin de recherche (Par defaut : "^(!chemin_recherche)^" )" )) ;
	  ("-k",Arg.String(fun s ->  if(!premier) then (premier:=false;kernel:=[s]) else kernel:=s::(!kernel) ) ,("Nom du fichier kernel.ml (Par defaut : "^(List.hd(!kernel))^" )" )) ;
	  ("-l",Arg.String(fun s ->  fichier_liste:=s) ,("Nom du fichier LIST_dispatch.txt (Par defaut : "^(!fichier_liste)^" )" )) ;
	  ("-d",Arg.String(fun s ->  chemin_doc:=s) ,("Chemin vers la doc (Par defaut : "^(!chemin_doc)^" )" )) ;

		  ] (fun _ -> ()) usage;






if(!mode_verbose) then Printf.printf " Demarrage de la creation de la doc \n";
	try	
	
		(*let descrfichier= Unix.openfile ((!chemin_recherche)^"/"^(!fichier_liste))  [Unix.O_RDONLY] 0o755 in
		let text = Outil.lire descrfichier in
		Unix.close  descrfichier;*)
		  let chan = open_in ((!chemin_recherche)^"/"^(!fichier_liste)) in
		  let lexbuf = Lexing.from_channel chan in
	
		(*let lexbuf = Lexing.from_string text in*)
		let result = Type_yacc.depart  Type_lex.lexer lexbuf in

		  close_in chan;

if(!mode_verbose) then Printf.printf " Fichier LIST correct \n";
if(!mode_verbose) then Printf.printf "\n\n Type \n";
		let liste_type_range = List.sort compare (fst result)
		and liste_fonction_range = List.sort compare_type_fonction (snd result)
		in

if(!mode_verbose) then affichage_type liste_type_range;
if(!mode_verbose) then Printf.printf "\n\n Fonction\n";
if(!mode_verbose) then affichage_fonction liste_fonction_range;
                creation_type_mli ("unit"::"collection"::"newtonian"::"leibnizian"::"scalar"::"monoidal"::liste_type_range);
		
		flush_all();




                let kfonc l s =
		  let chan = open_in ((!chemin_recherche)^"/"^(s))  in
		  let lexbuf = Lexing.from_channel chan in
                 (* let descrfichier2= Unix.openfile ((!chemin_recherche)^"/"^(s))  [Unix.O_RDONLY] 0o755 in
		  let text2 = Outil.lire descrfichier2 in
		    Unix.close  descrfichier2;
		   *)(* let textdec = decoupage_text text2 in
		     *) 
		  (*  let lexbuf2 = Lexing.from_string text2(*dec*) in*)
if(!mode_verbose) then Printf.printf " Fichier KERNEL %s  correct \n" s;
                    let lll=((*Fonction_yacc.depart*)  Fonction_lex.lexer lexbuf)(*@l*)
		    in
		    close_in chan;
		      lll;



		in


		let result2 = List.fold_left kfonc [] (!kernel) in

		(*affichage_fonction_brut result2;*)
		
		let m = ranger result2
		in 

if(!mode_verbose) then afficher_module m;
		 
		creation_mli m liste_fonction_range;
		

		let pwd = Sys.getcwd() in
	        let descrfichier2= Unix.openfile ("liste_module") [Unix.O_WRONLY;Unix.O_CREAT;Unix.O_TRUNC] 0o755 		in
		let chaine ="DOC="^pwd^"/"^(!chemin_ecriture)^"\nECRITURE="^pwd^"/"^(!chemin_doc)^"\nMLI2=" in
		let _=Unix.write descrfichier2 chaine 0 (String.length chaine)
	        in
		creation_liste_module m descrfichier2 pwd;
		let chaine2 ="\nMLI=" in
		let _=Unix.write descrfichier2 chaine2 0 (String.length chaine2)
	        in
		creation_liste_module2 m descrfichier2;
		Unix.close descrfichier2;
		
	with Unix.Unix_error(x,y,z)->(flush_all();Printf.printf "********************************\n%s %s %s\n" (Unix.error_message x) y z;exit 1)
	  |Sys_error s ->(flush_all();Printf.printf "******************************************\n%s\n" s;exit 1;)
	  (*|_->(flush_all();prerr_endline "****************Probleme*********************";exit 1;)*)
	
