(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: kernel_bag.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2004-08-13 21:01:57 $
 * Version: $Revision: 1.1 $
 * -------------------------------------------------------------------
 *
 * Status: 
 *   voir aussi Common/kernel_collection.ml
 *   qui contient les fcts gnriques sur les collections et les monoidaux.
 *
 *=========================================================================
 *)

open Global;;
open Valeur;;
open Type;;
open Dispatch_sig;;
open Dispatch;;
open Environnement;;
open Bag;;


__register_version "$RCSfile: kernel_bag.ml,v $" "$Revision: 1.1 $" "$Date: 2004-08-13 21:01:57 $";;


print_string "(* loading kernel functions on BAG into user-space ... ";
flush Pervasives.stdout;;



(**
  @module collections
  @name 'bagify
  @type collection_bag
  @type scalar_bag

  Transform its argument into a bag.
  ['bagify(c)] collects allthe elements of the collection
  [c] into a bag. If [c] is already a bag, [bagify] is the identity.
  
  ['bagify(s)] where [s] is a scalar returns
  the bag with [s] as the unique element.
*)
addenv_impure "'bagify"  (fun_1 __bagify );;



(* --- fin de l'installation des fonctions de base --- *)

print_string "done *)";
print_newline();;

(* ======================================================= *)
