(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: def_gbf.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2004-12-14 14:57:27 $
 * Version: $Revision: 1.2 $
 * -------------------------------------------------------------------
 *
 * Status:  
 *     La representation d'un GBF.
 *
 *=========================================================================
 *)

Global.__register_version "$RCSfile: def_gbf.ml,v $" "$Revision: 1.2 $" "$Date: 2004-12-14 14:57:27 $";;


type gbf_type      = Abelian  | NonAbelian
and matrice        = (int array) array
and gen_expr_array = gbf_expr array
and gbf_stub_id    = int
and generateurs    = string array

and gbf_def        =
    {
      gbf_name            : string;           (* Le nom du GBF              *)
      gbf_type            : gbf_type;         (* Abelien ou non             *)
      generateurs         : generateurs;      (* Le tableau des generateurs *)
      matrice             : matrice;          (* La matrice de FNS          *)
      gbf_id              : gbf_stub_id;      (* L'id du GBF pour le stub   *)
      gbf_neighbors_array : gbf_coord array   (* Le tableau des chemins pour atteindre les voisins *)
    }

and gbf_op   =  GBF_plus | GBF_moins
and gbf_sign = Positif | Negatif
and gbf_expr = 
  | GBF_mult of int * gbf_expr
  | GBF_op of gbf_op * gbf_expr * gbf_expr
  | GBF_equal of gbf_expr * gbf_expr
  | GBF_gen of gbf_sign * string
  | GBF_zero                                  


and gbf_coord = int array
and posgbf    = gbf_coord * gbf_def

and 'a tgbf   = (gbf_coord, 'a) Hash.t
;;
