(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: core_graph.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2005-11-23 11:10:57 $
 * Version: $Revision: 1.2 $
 * -------------------------------------------------------------------
 *
 * Status: 
 *=========================================================================
 *)

open Global;;
open Valeur;;


Global.__register_version "$RCSfile: core_graph.ml,v $" "$Revision: 1.2 $" "$Date: 2005-11-23 11:10:57 $";;



(* (int * Valeur.MGS_value * (int * string) list) list *)


let deco (x, _) = x
and vois (_, x) = x
;;

let process liste_sommets =
  let taille         = List.length liste_sommets in
  let assoc_tbl      = Hash.create taille
  and cpt            = ref 0
  and nb_arcs_nommes = ref 0 
  in
    List.iter 
      (function (idx, _, voisins) -> (Hash.add assoc_tbl idx !cpt;
				      nb_arcs_nommes := (List.fold_right (fun (_, nom) y -> (if (nom <> "") then 1 else 0)+y) voisins !nb_arcs_nommes);
				      incr cpt))
      liste_sommets;
    let arcs_tbl = Hash.create !nb_arcs_nommes in
    let tabl     = Array.init taille (function idx -> (let (_, valeur, voisins) = List.nth liste_sommets idx
						       in
							 valeur, List.sort Pervasives.compare (List.map
								    (function (sommet, label) -> (let vrai_sommet = Hash.find assoc_tbl sommet
												  in
												    if (label <> "")
												    then Hash.add arcs_tbl label vrai_sommet;
												    vrai_sommet))
								    voisins)))
    in
      (*VAL_grf ((arcs_tbl, tabl), Type_graph.graph_desc)*)
      (arcs_tbl, tabl)
;;


let remove idx (tbl, tab) =
  let len = Array.length tab
  in
    if ((idx >= len) or (idx < 0))
    then raise (Erreur (Printf.sprintf "remove : cannot remove the %dth element of a graph of size %d" idx len))
    else (let ret = Array.init 
		      (len - 1)
		      (fun index -> (let src = if (index >= idx) then (index+1) else index in
				     let deco, voisins = tab.(src)
				     in
				       deco, (List.fold_right (fun v s -> if (v = idx) then s else v::s) voisins [])))
	  in
	    (tbl, ret)) (*VAL_grf ((tbl, ret), deco))*)

(*
let remove idx tab = 
  let len = Array.length tab 
  in 
    Array.init (len - 1) (fun index -> tab.(if (index >= idx) then (index+1) else index))
*)

