(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: def_qmf.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG, AS
 * Modified: $Date: 2005-01-13 00:59:13 $
 * Version: $Revision: 1.3 $
 * -------------------------------------------------------------------
 *
 * Status:  
 *     Une QMF est donne par:
 *       _ une gmap ;
 *       _ un tableau de tables de hashage, chaque table correspondant 
 *         une dimension. Les gmaps sont pour l'instant restreinte  la
 *         dimension 3 ;
 *       _ la dimension de la gmaps et de la qmf.
 *
 *=========================================================================
 *)

Global.__register_version "$RCSfile: def_qmf.ml,v $" "$Revision: 1.3 $" "$Date: 2005-01-13 00:59:13 $";;


(* Le type de position dans une QMF est la ncell
 * Pour des renseignements sur les types abstraits gmap, dart et coverage,
 * cf stub_gmap_ml.c, stub_gmap_ml.h et stub_gmap.cc
 *)

type gmap
and  dart
and  coverage
and  ncell = gmap * dart * int

and 'a qmf = gmap * ((ncell, 'a) Hash.t) array * int
