(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: printer_qmf.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG, AS
 * Modified: $Date: 2005-02-01 16:29:39 $
 * Version: $Revision: 1.6 $
 * -------------------------------------------------------------------
 *
 * Status: Cf. Qmf/def_qmf.ml pour les infos sur les types qmf et ncell
 *          
 *
 *=========================================================================
 *)


open Printf ;;
open Def_qmf ;;
open Printer;;
open Valeur;;


(** on etend la fct d'affichage non-formattee **) 

let rec string_of_gmap g = Core_qmf.string_of_gmap g

and string_of_ncell c = Core_qmf.string_of_ncell c

and  _uprbval_'outBuffer_gmap (b, x) =  
  bprintf b "%s" (string_of_gmap x);
  valundef

and  _uprbval_'outBuffer_ncell (b, x) =
  bprintf b "%s" (string_of_ncell x);
  valundef

and _upobval1_'outBuffer_string_string_string_funct_gmap (b,pre,inter,post,f,x) =
  bprintf b "%s" (string_of_gmap x);
  valundef

and _upobval1_'outBuffer_string_string_string_funct_ncell (b,pre,inter,post,f,x) =
  bprintf b "%s" (string_of_ncell x);
  valundef




and _pfbval_'outBufferF_gmap (b, x) = 
  Format.fprintf b "%s" (string_of_gmap x);
  valundef

and _pfbval_'outBufferF_ncell (b, x) = 
  Format.fprintf b "%s" (string_of_ncell x);
  valundef

and _pobval1_'outBufferF_int_string_string_string_funct_gmap (b,t,pre,inter,post,f,x) =
  Format.fprintf b "%s" (string_of_gmap x);
  valundef

and _pobval1_'outBufferF_int_string_string_string_funct_ncell (b,t,pre,inter,post,f,x) =
  Format.fprintf b "%s" (string_of_ncell x);
  valundef

;;







let rec _uprbval_'outBuffer_qmf (b, (q, t)) =
  begin
    bprintf b "%s:{|" t.name;
    let cpt = ref (Core_qmf.size q) in
      Core_qmf.iter 
	(fun ncell v -> 
	   decr cpt;
	   bprintf b "%a @ %a%s" 
	     Printer.unformatted_prbvalue2 v 
	     Printer.unformatted_prbvalue2 (VAL_ncell ncell)
	     (if !cpt = 0 then " " else ", "))	
	q;
      bprintf b "|}";
      Valeur.mgsundef
  end

and plist_aux pps ppval sep x f = match x with
  | [] -> ()
  | a::[] -> ppval (f a); ()
  | a::l -> (ppval (f a)); (pps sep); plist_aux pps ppval sep l f

and _upobval1_'outBuffer_string_string_string_funct_qmf (b,pre,inter,post,f,x) =
  Printf.bprintf b "%s " pre;
  plist_aux (Printf.bprintf b "%s")
            (Printf.bprintf b "%a" uprbvalue2  )
            inter
            (List.map snd (Core_qmf.to_list (fst x)))
            f;
  Printf.bprintf b " %s" post;
  valundef

and _pfbval_'outBufferF_qmf (b, (q, t)) = 
  begin
    Format.fprintf b "%s:@[<hv>{| @[<hv>" t.name;
    let cpt = ref (Core_qmf.size q) in
      Core_qmf.iter 
	(fun ncell v -> 
	   decr cpt;
	   Format.fprintf b "%a @@ %a" 
	     Printer.prbvalue2 v 
	     Printer.prbvalue2 (VAL_ncell ncell);
	   (if !cpt <> 0 then Format.fprintf b ",@,"))
	q;
      Format.fprintf b " @]@,|}@]";
      Valeur.mgsundef
  end

and plist_aux2 pps ppval sep x f = match x with
  | [] -> ()
  | a::[] -> ppval (f a); ()
  | a::l -> (ppval (f a)); (pps sep); plist_aux2 pps ppval sep l f 

and _pobval1_'outBufferF_int_string_string_string_funct_qmf (b,t,pre,inter,post,f,x) =
  Format.pp_open_box b t;
  Format.fprintf b "%s " pre;
  plist_aux2 (Format.fprintf b "%s@,")
             (Format.fprintf b "%a" pfbvalue2  )
             inter
             (List.map snd (Core_qmf.to_list (fst x)))
             f;
  Format.fprintf b " %s@]@," post;
  valundef
;;


