(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: type_ring.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2005-11-23 11:10:57 $
 * Version: $Revision: 1.3 $
 * -------------------------------------------------------------------
 *
 * Voir le fichier Common/type.ml
 * 
 *=========================================================================
 *)



open Global;;
open Valeur;;
open Type;;

__register_version "$RCSfile: type_ring.ml,v $" "$Revision: 1.3 $" "$Date: 2005-11-23 11:10:57 $";;





(*!*)(** 
       @module collections
       @name 'ring
       @type any_bool
       Ring type and predicate.
       @voir 'set      'set
       @voir 'bag      'bag
       @voir 'seq      'seq
       @voir 'ring     'ring
       @voir 'monoidal 'monoidal
*)(*!*)

let ring_desc = create_type
		 { name = "'ring";
		   concrete = true;
		   leibniz = true;
		   predicate = wrap_pred(is_leibniz);
		   empty = VAL_undef "dummy for empty field in type descriptor 'ring";
		   pospredicate = pospredicate_int;
		   make = make_dummy;
		   xxxify = xxxify_dummy "'ring";
		   derive_from = [monoidal_desc];
		   father_of = [];
		   uid = get_new_uid();
		 }
;;

ring_desc.predicate <- wrap_pred(coll_pred ring_desc);;

(** !!! Attention !!!
 *** Ne pas oublier de mettre  jour les champs
 ***     _ make 
 ***     _ xxxify
 ***     _ empty
 *** du descripteur de type dans le fichier ring.ml
 ***)

