(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: keyword.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2008-05-20 10:13:50 $
 * Version: $Revision: 1.6 $
 * -------------------------------------------------------------------
 *
 * Status: 
 *=========================================================================
 *)

open Global;;
open Parser;;

__register_version "$RCSfile: keyword.ml,v $" "$Revision: 1.6 $" "$Date: 2008-05-20 10:13:50 $";;


let keyword_table =
  let tbl =  (Hash.create 7 : (string, token) Hash.t)
  and liste = [
    ("abstract"  , ABSTRACT);
    ("additive"  , PARALL);
    ("and"       , ANDDEF);
    ("arrow"     , ARROW_SPEC);
    ("as"        , AS);
    ("case"      , CASE);
    ("collection", COLLECTION);
    ("default"   , DEFAULT);
    ("constraint", CONSTRAINT);
    ("delaunay"  , DELAUNAY);
    ("do"        , DO);
    ("else"      , ELSE);
    ("eval"      , EVAL);
    ("endswitch" , ENDSWITCH);
    ("false"     , FALSE);
    ("fi"        , ENDIF);
    ("flat"      , FLAT);
    ("following" , FOLLOWING);
    ("fun"       , FUN);
    ("gbf"       , GBF);
    ("if"        , IF);
    ("in"        , IN);
    ("let"       , LET);
    ("nil"       , (UNDEF ""));
    ("notin"     , NOTIN);
    ("on"        , ON);
    ("patch"     , PATCH);
    ("priority"  , PRIORITY);
    ("proximal"  , PROXIMAL);
    ("qmf"       , QMF);
    ("raise"     , RAISE);
    ("record"    , RECORD);
    ("return"    , RETURN);
    (*"state"     , STATE);*)
    ("switch"    , SWITCH);
    ("then"      , THEN);
    ("trans"     , TRANSFORM);
    ("trans2"    , TRANSFORM2);
    ("true"      , TRUE);
    ("try"       , TRY);
    ("try"       , TRY);
    ("when"      , WHEN);
    ("while"     , WHILE);
    ("with"      , WITH)
  ]
  in
    List.iter (function (nom, cle) -> Hash.add tbl nom cle) liste;
    tbl

and commande_table      =(let tbl =  (Hash.create 7 : (string, token) Hash.t)
			  and add = Hash.add
                          in 
			    add tbl "clear"      CLEAR;
			    add tbl "collection" COLLECTION;
			    add tbl "eval"       EVAL;
			    add tbl "exit"       QUIT; 
			    add tbl "gc"         GC;
			    add tbl "help"       HELP;
			    add tbl "include"    INCLUDE;
			    add tbl "legal"      LEGAL;
			    add tbl "compile"    COMPILE;
			    add tbl "list"       LIST;
			    add tbl "output"     OUTPUT;
			    add tbl "position"   POSITION;
			    add tbl "quit"       QUIT; 
			    add tbl "record"     RECORD;
			    add tbl "struct"     STATE;
			    add tbl "state"      STATE;
			    add tbl "run"        RUN;
			    add tbl "set"        SETPARAM;
			    add tbl "trace"      TRACE;
			    add tbl "untrace"    UNTRACE;
			    add tbl "type"       TYPE;
			    add tbl "version"    VERSION;
                            tbl)
;;

let get_commande x = Hash.find commande_table (String.lowercase x)
and get_keyword  x = Hash.find keyword_table  (String.lowercase x)
;;
