/*
 *
 *                              MGS
 *                              LaMI
 *                       Universite d'Evry Val d'Essonne
 *                   Olivier MICHEL, Jean-Louis GIAVITTO
 * File: $RCSfile: stub_unix.c,v $ 
 * Path: %P%
 * Description:
 * Created:
 * Author: Olivier Michel & Jean-Louis Giavitto
 * Modified: $Date: 2004-09-23 10:27:00 $ at 
 * Version: $Revision: 1.1 $
 * Status:
 *
 */

#include <stdlib.h>
#include <mlvalues.h>       /* for OCAML */
#include <memory.h>

/* man 3 mktemp : 

CONFORMING TO
       BSD 4.3. POSIX dictates tmpnam(3).

  gcc d'un fichier .c contenant tmpnam(3) :

stub_unix.o: In function `unix_mktemp':
stub_unix.o(.text+0x75): the use of `tmpnam' is dangerous, better use `mkstemp'

Donc on va utiliser mkstemp() !!!!!
*/

value  unix_mkstemp(value string_arg)
{
  CAMLparam1(string_arg);
  CAMLlocal1(ret);

  int taille = string_length(string_arg), fd;
  char *chaine;

  chaine = (char *)malloc((taille+1)*sizeof(char));
  if (chaine == NULL) failwith("stub_unix : mkstemp failed on malloc");
  strcpy(chaine, String_val(string_arg));
  fd = mkstemp(chaine);
  if (fd == -1) failwith("stub_unix : mkstemp error on mkstemp call");
  ret = alloc_tuple(2);
  Store_field(ret, 0, copy_string(chaine));
  Store_field(ret, 1, Val_int((int)fd));                                      /* d'apres open.c de /otherlibs/unix de la distro OCAML */
  free(chaine);
  CAMLreturn(ret);
}
