(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: kombinator.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2004-09-23 21:24:23 $
 * Version: $Revision: 1.1 $
 * -------------------------------------------------------------------
 *
 * Status: 
 *=========================================================================
 *)

open Global;;
open Valeur;;


__register_version "$RCSfile: kombinator.ml,v $" "$Revision: 1.1 $" "$Date: 2004-09-23 21:24:23 $";;




(** -------------- combinateur ------------------------------------ **)




(** representation MGS des combinateurs **)

let rec mgs_combI = VAL_funct (function x -> x)

and mgs_combK = VAL_funct (function a -> VAL_funct (function _ -> a))

and mgs_combB = 
  VAL_funct (function f -> let ff = pf1 f in
  VAL_funct (function a -> let aa = pf1 a in
  VAL_funct (function x -> ff(aa x) )))


and mgs_combC = 
  VAL_funct (function f -> let ff = pf1 f in
  VAL_funct (function a -> 
  VAL_funct (function x -> (pf1 (ff (x)))(a) )))

and mgs_combS =
  VAL_funct (function f -> let ff = pf1 f in
  VAL_funct (function a -> let aa = pf1 a in 
  VAL_funct (function x -> (pf1 (ff(x)))(aa(x))) ))


and mgs_combS4 =
  VAL_funct (function f -> let ff = pf1 f in
  VAL_funct (function a -> let aa = pf1 a in 
  VAL_funct (function b -> let bb = pf1 b in 
  VAL_funct (function x -> 
    (pf1 (ff (aa x))) (bb x)) )))

and mgs_combIF =
  VAL_funct (function c -> let cc = pf1 c in	
  VAL_funct (function p -> let pp = pf1 p in
  VAL_funct (function q -> let qq = pf1 q in
  VAL_funct (function x -> 
	       match Dispatch.__val2bool (cc x) with VAL_bool true -> pp(x) | _ -> qq(x) ))))
;;



(** (S4 S) a b x y = S (a x) (b x) y = (a x y) (b x y) 
 ** on cree un combinateur dedie, un short-cut, utilise 
 ** dans une optimisation...
 **)
let mgs_combS4_S = 
  VAL_funct(function a -> let aa = pf1 a in
  VAL_funct(function b -> let bb = pf1 b in
  VAL_funct(function x -> 
	      let aax = pf1 (aa x) and bbx = pf1 (bb x) in
		VAL_funct(function y -> 
			    let ff = pf1 (aax y) and xx = bbx y in
			      (ff xx)))))

(** B K f x y == f x **)
and mgs_combB_K =
  VAL_funct(function f -> let ff = pf1 f in
  VAL_funct(function x ->
    VAL_funct(function _ -> ff x)))
;;

(***
  | C_B4   (*  B4 f a b x = f (a x) b      *)
  | C_C4   (*  C4 f a b x = f a (b x)      *)    
  | C_Bop1 of string   (*  Bop a x = op1(a(x))          *)

  | C_Aop2 of string   (*  Aop a b x = op2 a b          *)
  | C_Bop2 of string   (*  Bop a b x = op2 (a x) b      *)
  | C_Cop2 of string   (*  Cop a b x = op2 a (b x)      *)
  | C_Sop2 of string   (*  Sop a b x = op2 (a x) (b x)  *)

***)

let mgs_combS4B4 = 
  VAL_funct(function f -> let ff = pf1 f in
  VAL_funct(function a -> let aa = pf1 a in 
  VAL_funct(function _ ->
  VAL_funct(function x -> (pf1 (ff (aa x))) x) )))

and mgs_combS4C4 = 
  VAL_funct(function f -> let ff = pf1 f in
  VAL_funct(function a -> 
  VAL_funct(function b -> let bb = pf1 b in 
  VAL_funct(function x -> (pf1 (ff a)) (bb x)) )))
;;

