/*
 * lib-gmapkernel : Un noyau de 3-G-cartes et des oprations.
 * Copyright (C) Moka Team, moka@sic.univ-poitiers.fr
 *               http://www.sic.univ-poitiers.fr/moka/
 *
 * This file is part of lib-gmapkernel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//******************************************************************************
// Ce fichier fait partie de "g-map-generic.hh".
//******************************************************************************

public:

/**
 * Ces mthodes permettent de composer les involutions pour accder
 * facilement aux brins de la carte. Les indices sont donns selon
 * l'ordre dans lequel ils sont appliqus.
 * Exemple: alpha123(d) signifie alpha3(alpha2(alpha1(d))).
 *
 * @param ADart Un pointeur sur un brin quelconque
 * @return Un pointeur sur un brin
 */
CDart* alpha01     (CDart* ADart) const;
CDart* alpha010    (CDart* ADart) const;
CDart* alpha0101   (CDart* ADart) const;
CDart* alpha0101210(CDart* ADart) const;
CDart* alpha01010  (CDart* ADart) const;
CDart* alpha01021  (CDart* ADart) const;
CDart* alpha0102101(CDart* ADart) const;
CDart* alpha010212 (CDart* ADart) const;
CDart* alpha012    (CDart* ADart) const;
CDart* alpha0121   (CDart* ADart) const;
CDart* alpha0123   (CDart* ADart) const;
CDart* alpha012321 (CDart* ADart) const;
CDart* alpha02     (CDart* ADart) const;
CDart* alpha020    (CDart* ADart) const;
CDart* alpha021    (CDart* ADart) const;
CDart* alpha0210   (CDart* ADart) const;
CDart* alpha02101  (CDart* ADart) const;
CDart* alpha02121  (CDart* ADart) const;
CDart* alpha023    (CDart* ADart) const;
CDart* alpha03     (CDart* ADart) const;
CDart* alpha030    (CDart* ADart) const;
CDart* alpha10     (CDart* ADart) const;
CDart* alpha101    (CDart* ADart) const;
CDart* alpha1010   (CDart* ADart) const;
CDart* alpha10101  (CDart* ADart) const;
CDart* alpha1010101(CDart* ADart) const;
CDart* alpha1012   (CDart* ADart) const;
CDart* alpha10121  (CDart* ADart) const;
CDart* alpha101201 (CDart* ADart) const;
CDart* alpha1012101(CDart* ADart) const;
CDart* alpha101232 (CDart* ADart) const;
CDart* alpha102    (CDart* ADart) const;
CDart* alpha1021   (CDart* ADart) const;
CDart* alpha12     (CDart* ADart) const;
CDart* alpha121    (CDart* ADart) const;
CDart* alpha1210   (CDart* ADart) const;
CDart* alpha12101  (CDart* ADart) const;
CDart* alpha1212   (CDart* ADart) const;
CDart* alpha123    (CDart* ADart) const;
CDart* alpha1232   (CDart* ADart) const;
CDart* alpha12321  (CDart* ADart) const;
CDart* alpha123210 (CDart* ADart) const;
CDart* alpha13     (CDart* ADart) const;
CDart* alpha20     (CDart* ADart) const;
CDart* alpha201    (CDart* ADart) const;
CDart* alpha21     (CDart* ADart) const;
CDart* alpha210    (CDart* ADart) const;
CDart* alpha2101   (CDart* ADart) const;
CDart* alpha21012  (CDart* ADart) const;
CDart* alpha210123 (CDart* ADart) const;
CDart* alpha212    (CDart* ADart) const;
CDart* alpha2121   (CDart* ADart) const;
CDart* alpha23     (CDart* ADart) const;
CDart* alpha231    (CDart* ADart) const;
CDart* alpha2310   (CDart* ADart) const;
CDart* alpha2321   (CDart* ADart) const;
CDart* alpha232101 (CDart* ADart) const;
CDart* alpha30     (CDart* ADart) const;
CDart* alpha3012   (CDart* ADart) const;
CDart* alpha30120  (CDart* ADart) const;
CDart* alpha302    (CDart* ADart) const;
CDart* alpha31     (CDart* ADart) const;
CDart* alpha32     (CDart* ADart) const;
CDart* alpha3201   (CDart* ADart) const;
CDart* alpha321    (CDart* ADart) const;
CDart* alpha321012 (CDart* ADart) const;
CDart* alpha323    (CDart* ADart) const;

/**
 * Retourne le champ directInfo demand du brin ADart aprs l'avoir
 * retyp en pointeur sur un brin.
 *
 * @param ADart Un brin de la carte
 * @param ADirectInfoIndex Un indice de champ directInfo
 * @return Un brin de la carte
 */
CDart* getDirectInfoAsDart(CDart* ADart, int ADirectInfoIndex);

//******************************************************************************
