/*
 * lib-gmapkernel : Un noyau de 3-G-cartes et des oprations.
 * Copyright (C) Moka Team, moka@sic.univ-poitiers.fr
 *               http://www.sic.univ-poitiers.fr/moka/
 *
 * This file is part of lib-gmapkernel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//******************************************************************************
// Ce fichier est une partie de "gmap-generic.hh".
//******************************************************************************

public:

/**
 * Dcoud selon la dimension ADim tous les brins de la cartes marqus avec
 * la marque numro AMarkNumber.
 *
 * @param AMarkNumber Un numro de marque
 * @param ADim Une dimension
 * @return Le nombre de dcousures effectues
 */
int unsewMarkedCells(int AMarkNumber, int ADim);

/**
 * Dcoud tous les brins de la carte marqus, en dterminant de manire
 * automatique la dimension de chacune des dcousures.
 *
 * @param AMarkNumber Un numro de marque
 * @return Le nombre de dcousures effectues
 */
int intuitiveUnsewMarkedCells(int AMarkNumber);

//******************************************************************************
