/*
 * lib-gmapkernel : Un noyau de 3-G-cartes et des oprations.
 * Copyright (C) Moka Team, moka@sic.univ-poitiers.fr
 *               http://www.sic.univ-poitiers.fr/moka/
 *
 * This file is part of lib-gmapkernel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//******************************************************************************
// Ce fichier fait partie de "g-map-vertex.hh".
//******************************************************************************

public:

/**
 * Fusionne lorsque cela est possible (avec une arte qui leur est incidente)
 * les artes dont un brin au moins est marqu, lorsqu'elles sont alignes.
 *
 * @param AMarkNumber Un numro de marque
 * @param ADeleteDarts Un boolen indiquant si la fusion doit se faire en
 *   supprimant des brins
 * @return Le nombre de fusions effectues
 */
int mergeMarkedColinearEdges(int AMarkNumber, bool ADeleteDarts);

/**
 * Fusionne lorsque cela est possible (avec une face qui leur est incidente)
 * les faces dont un brin au moins est marqu, lorsqu'elles sont coplanaires.
 *
 * @param AMarkNumber Un numro de marque
 * @param ADeleteDarts Un boolen indiquant si la fusion doit se faire en
 *   supprimant des brins
 * @return Le nombre de fusions effectues
 */
int mergeMarkedCoplanarFaces(int AMarkNumber, bool ADeleteDarts);

/**
 * Fusionne lorsque cela est possible les artes ou les faces alignes.
 *
 * @param ADim La dimension (1 ou 2) des cellules  fusionner
 * @param AMarkNumber Un numro de marque
 * @param ADeleteDarts Un boolen indiquant si la fusion doit se faire en
 *   supprimant des brins
 * @return Le nombre de fusions effectues
 */
int mergeMarkedAlignedCells(int ADim, int AMarkNumber, bool ADeleteDarts);

//******************************************************************************
