/*
 * lib-gmapkernel : Un noyau de 3-G-cartes et des oprations.
 * Copyright (C) Moka Team, moka@sic.univ-poitiers.fr
 *               http://www.sic.univ-poitiers.fr/moka/
 *
 * This file is part of lib-gmapkernel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//******************************************************************************
#include "g-map-vertex.hh"
using namespace GMap3d;
//******************************************************************************
int CGMapVertex::deleteNullLengthEdges()
{
  int mark = getNewMark();
  negateMaskMark(mark);
  int result = deleteMarkedNullLengthEdges(mark);
  negateMaskMark(mark);
  freeMark(mark);
  return result;
}
//------------------------------------------------------------------------------
int CGMapVertex::deleteMarkedNullLengthEdges(int AMarkNumber)
{
  int toContract = getNewMark();
  int treated = getNewMark();

  for (CDynamicCoverageAll it(this) ; it.cont(); ++it )
    if (isMarked(*it, AMarkNumber))
      {
	if (! isMarked(*it, treated))
	  {
	    if (!isFree0(*it) && *findVertex(*it)==*findVertex(alpha0(*it)))
	      setMark(*it, toContract);
	    
	    markOrbit(*it, ORBIT_EDGE, treated);
	  }
      }
    else
      setMark(*it, treated);

  int deleted = contractMarkedCells(toContract, 1, true);

  freeMark(toContract);
  negateMaskMark(treated);
  freeMark(treated);
  
  return deleted;
}
//******************************************************************************
