/*
 * lib-gmapkernel : Un noyau de 3-G-cartes et des oprations.
 * Copyright (C) Moka Team, moka@sic.univ-poitiers.fr
 *               http://www.sic.univ-poitiers.fr/moka/
 *
 * This file is part of lib-gmapkernel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//******************************************************************************
#include "g-map-vertex.hh"
using namespace GMap3d;
//******************************************************************************
CDart * CGMapVertex::triangulateEdge(CDart * ADart)
{
  assert(ADart!=NULL);
  // Inutile d'affecter un plongement au nouveau sommet cr, car
  // CGMapGeneric::triangulateEdge fait appel  la mthode
  // CGMapGeneric::insertVertex qui est virtuelle.
  // La mthode CGMapVertex::insertVertex est donc appele.
  // C'est elle qui se charge de plonger le nouveau sommet.
  return CGMapGeneric::triangulateEdge(ADart);
}
//******************************************************************************
CDart * CGMapVertex::triangulateFace(CDart * ADart)
{
  assert(ADart!=NULL);

  CVertex bary = barycenter(ADart, ORBIT_01);
  CDart * center= CGMapGeneric::triangulateFace(ADart);
  setVertex(center, bary);

  return center;
}
//******************************************************************************
CDart * CGMapVertex::triangulateVolume(CDart * ADart)
{
  assert(ADart!=NULL);

  CVertex bary = barycenter(ADart, ORBIT_012);
  CDart * center= CGMapGeneric::triangulateVolume(ADart);
  setVertex(center, bary);

  return center;
}
//******************************************************************************
