(** Compute the neighborhood of a vertex or some vertices in a graph
*)


(** Compute the neighborhood of a vertex or some vertices in a non-oriented graph
*)
module Graph :
  functor (G : Sig.G) ->
sig
  module VertexSet : Set.S with type elt = G.V.t
			   and type t = Set.Make(G.V).t
			     
  (** [of_vertex g v] computes the neighborhood of [v].
  *)
  val of_vertex : G.t -> G.V.t -> VertexSet.t
    
  (** [of_vertices g v] computes the neighborhood of each vertex and
    return their union excluding [v].
  *)
  val of_vertices : G.t -> VertexSet.t -> VertexSet.t
    
  (** [of_vertices g v] computes the neighborhood of each vertex and
    return their union excluding [v].
  *)
  val of_vertices_list : G.t -> VertexSet.elt list -> VertexSet.t
end
 
