(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      4595,        131]
NotebookOptionsPosition[      4201,        114]
NotebookOutlinePosition[      4534,        129]
CellTagsIndexPosition[      4491,        126]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{"ClearAll", "[", "Foldint", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Foldint", "[", 
   RowBox[{"f_", ",", "z_", ",", "0"}], "]"}], ":=", 
  "z"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Foldint", "[", 
   RowBox[{"f_", ",", "z_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"f", "[", 
   RowBox[{"n", ",", 
    RowBox[{"Foldint", "[", 
     RowBox[{"f", ",", "z", ",", 
      RowBox[{"n", "-", "1"}]}], "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.393835507768643*^9, 3.393835508073661*^9}, {
  3.393842126367217*^9, 3.393842288059069*^9}, {3.393842428097473*^9, 
  3.393842435073456*^9}, {3.393842504883882*^9, 3.393842510403395*^9}, {
  3.393844505236755*^9, 3.393844505680091*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.393842466335625*^9, 3.393842467069579*^9}}],

Cell[BoxData[{
 RowBox[{"ClearAll", "[", 
  RowBox[{"Charge", ",", "Chargebis"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Charge", "[", 
   RowBox[{"nb_", ",", "maxz_"}], "]"}], ":=", 
  RowBox[{"ListAnimate", "[", 
   RowBox[{"Foldint", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Join", "[", 
        RowBox[{"#2", ",", 
         RowBox[{"{", 
          RowBox[{"ListPlot3D", "[", 
           RowBox[{
            RowBox[{"Import", "[", 
             RowBox[{"\"\</tmp/essai\>\"", "<>", 
              RowBox[{"ToString", "[", "#1", "]"}], "<>", "\"\<.dat\>\""}], 
             "]"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"0", ",", "maxz"}], "}"}]}]}], "]"}], "}"}]}], "]"}], 
       ")"}], "&"}], ",", 
     RowBox[{"List", "[", "]"}], ",", "nb"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chargebis", "[", 
   RowBox[{"nb_", ",", "maxz_"}], "]"}], ":=", 
  RowBox[{"Foldint", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"Join", "[", 
       RowBox[{"#2", ",", 
        RowBox[{"{", 
         RowBox[{"ListPlot3D", "[", 
          RowBox[{
           RowBox[{"Import", "[", 
            RowBox[{"\"\</tmp/essai\>\"", "<>", 
             RowBox[{"ToString", "[", "#1", "]"}], "<>", "\"\<.dat\>\""}], 
            "]"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "maxz"}], "}"}]}]}], "]"}], "}"}]}], "]"}], 
      ")"}], "&"}], ",", 
    RowBox[{"List", "[", "]"}], ",", "nb"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.393842449835077*^9, 3.393842463024803*^9}, {
   3.393842514382323*^9, 3.393842527138994*^9}, {3.393842594679288*^9, 
   3.393842616395053*^9}, {3.393842759797657*^9, 3.393842943413322*^9}, 
   3.393843073710959*^9, {3.39384315259319*^9, 3.393843158954095*^9}, 
   3.393843256931055*^9, {3.393843371523168*^9, 3.393843381309297*^9}, {
   3.393843412873326*^9, 3.393843421107894*^9}, {3.393843537028403*^9, 
   3.393843632273486*^9}, {3.393843784272775*^9, 3.393843805620861*^9}, {
   3.393844439914239*^9, 3.393844446655979*^9}, {3.39384452094531*^9, 
   3.393844549553867*^9}, {3.393845207688071*^9, 3.393845225231017*^9}, {
   3.393845468164428*^9, 3.393845478727588*^9}}],

Cell[BoxData[
 RowBox[{"Chargebis", "[", 
  RowBox[{"20", ",", "100"}], "]"}]], "Input",
 CellChangeTimes->{{3.393844566937713*^9, 3.393844573042979*^9}, {
  3.393845229639483*^9, 3.393845230038779*^9}, {3.393845485999172*^9, 
  3.39384548620728*^9}, {3.39384554427556*^9, 3.393845544710874*^9}, {
  3.393845653447921*^9, 3.393845653515799*^9}}],

Cell[BoxData[
 RowBox[{"Charge", "[", 
  RowBox[{"20", ",", "100"}], "]"}]], "Input",
 CellChangeTimes->{{3.393845976099953*^9, 3.393845978874003*^9}}]
},
WindowSize->{1186, 824},
WindowMargins->{{0, Automatic}, {1, Automatic}},
FrontEndVersion->"6.0 for Linux x86 (32-bit) (April 20, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 725, 17, 77, "Input"],
Cell[1296, 40, 92, 1, 32, "Input"],
Cell[1391, 43, 2304, 56, 121, "Input"],
Cell[3698, 101, 345, 6, 32, "Input"],
Cell[4046, 109, 151, 3, 32, "Input"]
}
]
*)

(* End of internal cache information *)
